Index: imaps-frontend/src/App.jsx
===================================================================
--- imaps-frontend/src/App.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/App.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,6 +1,7 @@
 // eslint-disable-next-line no-unused-vars
-import React from "react";
-import {BrowserRouter as Router, Route, Routes} from "react-router-dom";
-import BrowseMaps from "./pages/BrowseMaps/BrowseMaps.jsx";
+import React, { useState, useEffect } from "react";
+import { BrowserRouter as Router, Routes, Route } from "react-router-dom";
+import FinkiMaps from "./pages/FinkiMaps/FinkiMaps";
+import Maps from "./pages/Maps/Maps";
 import LoginPage from "./pages/Login/Login";
 import Signup from "./pages/Signup/Signup";
@@ -10,50 +11,69 @@
 import ProtectedRoute from "./components/ProtectedRoute/ProtectedRoute";
 import "./App.css";
-import MapView from "./pages/MapView/MapView.jsx";
-import MyMaps from "./pages/MyMaps/MyMaps.jsx";
-
-import '@fontsource/roboto/300.css';
-import '@fontsource/roboto/400.css';
-import '@fontsource/roboto/500.css';
-import '@fontsource/roboto/700.css';
-import {AppProvider} from "./components/AppContext/AppContext.jsx";
-import AdminPage from "./pages/AdminPage/AdminPage.jsx";
-import {AuthCallback} from "./pages/AuthCallback.jsx";
-import PrivacyPolicy from "./pages/PrivacyPolicy/PrivacyPolicy.jsx";
-import TermsOfService from "./pages/TermsOfService/TermsOfService.jsx";
-
+import HttpService from "./scripts/net/HttpService";
 
 function App() {
+  const [isAuthenticated, setIsAuthenticated] = useState(false);
+  const [loading, setLoading] = useState(true);
 
+  useEffect(() => {
+    const token = localStorage.getItem("token");
+    const httpService = new HttpService("http://localhost:8080/api/auth");
+
+    const verifyToken = async () => {
+      try {
+        const response = await httpService.get(`/verify?token=${token}`);
+        if (response.username) {
+          setIsAuthenticated(true);
+          console.log("good");
+        }
+      } catch (error) {
+        console.log("ERROR: ", error);
+        setIsAuthenticated(false);
+      } finally {
+        setLoading(false);
+      }
+    };
+
+    if (token) {
+      verifyToken();
+      //setLoading(false);
+    } else {
+      setIsAuthenticated(false);
+      setLoading(false);
+    }
+  }, []);
+
+  const handleLogin = (token) => {
+    localStorage.setItem("token", token);
+    setIsAuthenticated(true);
+  };
+
+  if (loading) {
     return (
+      <div className="loading-container">
+        <div className="spinner"></div>
+        <p>Loading, please wait...</p>
+      </div>
+    );
+  }
 
-        <AppProvider>
-            <Router>
-                <Routes>
+  return (
+    <Router>
+      <Routes>
+        <Route path="/" element={<IMaps />} />
+        <Route path="/Maps/FinkiMaps/View" element={<FinkiMaps />} /> 
+        <Route path="/Maps" element={<Maps />} />
+        <Route path="/Login" element={<LoginPage onLogin={handleLogin} />} />
+        <Route path="/Signup" element={<Signup />} />
 
-                    <Route element={<ProtectedRoute/>}>
-                        <Route path="/myMaps/Draw/:mapName" element={<Draw/>}/>
-                        <Route path="/myMaps" element={<MyMaps/>}/>
-                        <Route path="/myMaps/View/:mapName" element={<MapView isPrivate={true}/>}/>
-                        <Route path="/Admin" element={<AdminPage/>}/>
-                    </Route>
-                    <Route path="/" element={<IMaps/>}/>
-                    <Route path="/Maps/View/:mapName" element={<MapView isPrivate={false}/>}/>
-                    <Route path="/Maps" element={<BrowseMaps/>}/>
-                    <Route path="/auth-callback" element={<AuthCallback/>}/>
-                    <Route path={"/privacy-policy"} element={<PrivacyPolicy/>}/>
-                    <Route path={"/terms-of-service"} element={<TermsOfService/>}/>
+        <Route element={<ProtectedRoute isAuthenticated={isAuthenticated} />}>
+          <Route path="/Maps/FinkiMaps/Draw" element={<Draw />} />
+        </Route>
 
-
-                    <Route path="/Login" element={<LoginPage/>}/>
-                    <Route path="/Signup" element={<Signup/>}/>
-
-                    <Route path="*" element={<Error/>}/>
-                </Routes>
-            </Router>
-        </AppProvider>
-
-
-    );
+        <Route path="*" element={<Error />} />
+      </Routes>
+    </Router>
+  );
 }
 
Index: imaps-frontend/src/components/DrawGuide/DrawGuide.jsx
===================================================================
--- imaps-frontend/src/components/DrawGuide/DrawGuide.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/components/DrawGuide/DrawGuide.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -18,6 +18,6 @@
           <div onClick={toggleModal} className={styles.overlay}></div>
           <div className={styles.modalContent}>
-            <h2 className={styles.title}>How to Use the Map Builder</h2>
-            <p className={styles.paragraph}>Welcome to the Map Builder! Here you can create an indoor map, render it and enjoy!:</p>
+            <h2>How to Use the Map Builder</h2>
+            <p>Welcome to the Map Builder! Here you can create an indoor map, render it and enjoy!:</p>
             <br></br>
             <ul>
@@ -35,5 +35,5 @@
             </ul>
             <br></br>
-            <p className={styles.paragraph}>After completing your map, click the render button and go to the View page to see your full featured map!</p>
+            <p>After completing your map, click the render button and go to the View page to see your full featured map!</p>
 
             <button className={styles.closeModal} onClick={toggleModal}>
Index: imaps-frontend/src/components/EntranceModal/EntranceModal.jsx
===================================================================
--- imaps-frontend/src/components/EntranceModal/EntranceModal.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/EntranceModal/EntranceModal.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,248 @@
+import React, { useState, useEffect } from "react";
+import styles from "./EntranceModal.module.css";
+
+export default function EntranceModal(props) {
+  const [modal, setModal] = useState(false);
+  const [room, setRoom] = useState(null);
+  const [pins, setPins] = useState([]);
+
+  const [formData, setFormData] = useState({
+    name: "",
+    connectedRoom: "",
+    description: "",
+    availableRooms: [],
+    availablePins: [],
+    selectedPins: [],
+    isMainEntrance: false,
+    selectedPin: "",
+  });
+
+  const toggleModal = () => {
+    if (modal) {
+      room.info = formData;
+      props.map.updateRoomNames();
+      console.log("Se vikna");
+    }
+    setModal(!modal);
+  };
+
+  const handleInputChange = (e) => {
+    const { name, value, type, checked } = e.target;
+    setFormData((prevData) => ({
+      ...prevData,
+      [name]: type === "checkbox" ? checked : value,
+    }));
+
+    console.log(formData);
+  };
+
+  const addPinToList = () => {
+    if (!formData.selectedPin || pins.includes(formData.selectedPin)) return;
+
+    setPins((prevPins) => {
+      const updatedPins = [...prevPins, formData.selectedPin];
+
+      setFormData((prevFormData) => ({
+        ...prevFormData,
+        selectedPin: "",
+        selectedPins: updatedPins,
+      }));
+
+      return updatedPins;
+    });
+  };
+
+  const removePinFromList = (pinToRemove) => {
+    setPins((prevPins) => {
+      const updatedPins = prevPins.filter((pin) => pin !== pinToRemove);
+      setFormData((prevFormData) => ({
+        ...prevFormData,
+        selectedPins: updatedPins,
+      }));
+      return updatedPins;
+    });
+    props.map.removeConnection(formData.name, pinToRemove);
+  };
+
+  const saveDetails = () => {
+    if (room) {
+      room.info = formData;
+      toggleModal();
+    }
+  };
+
+  useEffect(() => {
+    const openModalHandler = (event) => {
+      const roomObj = event.detail.room;
+      setRoom(roomObj);
+
+      const savedPins = roomObj.info.selectedPins || [];
+
+      setFormData({
+        name: roomObj.info.name || "",
+        connectedRoom: roomObj.info.connectedRoom || "",
+        description: roomObj.info.description || "",
+        availablePins: event.detail.map.getConnections() || [],
+        availableRooms: event.detail.map.getRooms() || [],
+        isMainEntrance: roomObj.info.isMainEntrance || false,
+        selectedPin: "",
+        selectedPins: savedPins,
+      });
+
+      setPins(savedPins);
+      setModal(true);
+      event.detail.map.updateConnections();
+
+      console.log(savedPins, "Loaded pins on modal open");
+    };
+
+    window.addEventListener("openEntranceModalEvent", openModalHandler);
+
+    return () => {
+      window.removeEventListener("openEntranceModalEvent", openModalHandler);
+    };
+  }, []);
+
+  if (modal) {
+    document.body.classList.add(styles.activeModal);
+  } else {
+    document.body.classList.remove(styles.activeModal);
+  }
+
+  return (
+    <>
+      {/* <button onClick={toggleModal} className={styles.btnModal}>
+        Entrance Modal
+      </button> */}
+
+      {modal && (
+        <div className={styles.modal}>
+          <div onClick={toggleModal} className={styles.overlay}></div>
+          <div className={styles.modalContent}>
+            <h2>Enter Entrance Details</h2>
+            <form className={styles.form}>
+              {/* Entrance Name */}
+              <div className={styles.formGroup}>
+                <label htmlFor="name">Name:</label>
+                <input
+                  type="text"
+                  id="name"
+                  name="name"
+                  value={formData.name}
+                  onChange={handleInputChange}
+                  placeholder="Enter the entrance name" // Suggest user input
+                  required
+                />
+              </div>
+
+              {/* Select Room for Entrance */}
+              <div className={styles.formGroup}>
+                <label htmlFor="connectedRoom">Select room associated with entrance:</label>
+                <select
+                  id="connectedRoom"
+                  name="connectedRoom"
+                  value={formData.connectedRoom}
+                  onChange={handleInputChange}
+                  required
+                >
+                  <option value="">Select Room</option>
+                  {formData.availableRooms.map((room, index) => (
+                    <option key={index} value={room.name}>
+                      {room.name}
+                    </option>
+                  ))}
+                </select>
+              </div>
+
+              {/* Pins Dropdown for Hallway Navigation */}
+              <div className={styles.formGroup}>
+                <label htmlFor="selectedPin">Select connections:</label>
+                <select
+                  id="selectedPin"
+                  name="selectedPin"
+                  value={formData.selectedPin}
+                  onChange={handleInputChange}
+                  required
+                >
+                  <option value="">Select Connection</option>
+                  {formData.availablePins
+                    .filter(
+                      (pin) =>
+                        formData.selectedPins.includes(pin.name) === false &&
+                        pin.name !== "" &&
+                        pin.name !== formData.name
+                    )
+                    .map((pin, index) => (
+                      <option key={index} value={pin.name}>
+                        {pin.name}
+                      </option>
+                    ))}
+                </select>
+                <button type="button" onClick={addPinToList} className={styles.addButton}>
+                  Add Connection
+                </button>
+              </div>
+
+              {/* Display added pins */}
+              <h3>Connections:</h3>
+              <ul className={styles.pinList}>
+                {pins.length > 0 ? (
+                  pins.map((pin, index) => (
+                    <li key={index} className={styles.pinItem}>
+                      {pin}
+                      <button onClick={() => removePinFromList(pin)} className={styles.removeButton}>
+                        Remove
+                      </button>
+                    </li>
+                  ))
+                ) : (
+                  <li>No connections added</li>
+                )}
+              </ul>
+              <br />
+
+              {/* Description */}
+              <div className={styles.formGroup}>
+                <label htmlFor="description">Description:</label>
+                <textarea
+                  id="description"
+                  name="description"
+                  value={formData.description}
+                  onChange={handleInputChange}
+                  rows="3"
+                />
+              </div>
+
+              {/* Main Entrance Checkbox */}
+              <div className={styles.formGroupCheckbox}>
+                <input
+                  type="checkbox"
+                  id="isMainEntrance"
+                  name="isMainEntrance"
+                  checked={formData.isMainEntrance}
+                  onChange={handleInputChange}
+                />
+                <label htmlFor="isMainEntrance">Is Main Entrance?</label>
+              </div>
+
+              {/* Save Button */}
+              <div className={styles.formGroup}>
+                <button
+                  type="button"
+                  id="submit-details"
+                  onClick={saveDetails}
+                  className={styles.submitButton}
+                >
+                  Save
+                </button>
+              </div>
+            </form>
+            <button className={styles.closeModal} onClick={toggleModal}>
+              CLOSE
+            </button>
+          </div>
+        </div>
+      )}
+    </>
+  );
+}
Index: imaps-frontend/src/components/FilterBar/FilterBar.jsx
===================================================================
--- imaps-frontend/src/components/FilterBar/FilterBar.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/components/FilterBar/FilterBar.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,34 +1,32 @@
-import React, { useState, useEffect, useCallback } from "react";
+import React from "react";
 import styles from "./FilterBar.module.css";
 
-export default function FilterBar({roomTypes,map}) {
-  const [selectedCategory, setSelectedCategory] = useState("all");
-
-
-
-  const filterLocation = useCallback((category) => {
-    map.setFilter(category)
-    setSelectedCategory(category);
-  },[])
+function FilterBar() {
+  const filterLocation = (category) => {
+    console.log(`Filter locations by: ${category}`);
+    // filtering logic
+  };
 
   return (
     <div className={styles.wrapper}>
       <div className={styles.scrollableContainer}>
-        <button
-          className={`${styles.buttonValue} ${selectedCategory === "all" ? styles.active : ""}`}
-          onClick={() => filterLocation("all")}
-        >
+        <button className={styles.buttonValue} onClick={() => filterLocation("all")}>
           All
         </button>
-
-        {roomTypes?.map((roomType, index) => (
-          <button
-            key={index}
-            className={`${styles.buttonValue} ${selectedCategory === roomType.name ? styles.active : ""}`}
-            onClick={() => filterLocation(roomType.name)}
-          >
-            {roomType.name}
-          </button>
-        ))}
+        <button className={styles.buttonValue} onClick={() => filterLocation("Classrooms")}>
+          Classrooms
+        </button>
+        <button className={styles.buttonValue} onClick={() => filterLocation("Administrative")}>
+          Administrative
+        </button>
+        <button className={styles.buttonValue} onClick={() => filterLocation("Labs")}>
+          Labs
+        </button>
+        <button className={styles.buttonValue} onClick={() => filterLocation("Restrooms")}>
+          Restrooms
+        </button>
+        <button className={styles.buttonValue} onClick={() => filterLocation("Cafeteria")}>
+          Cafeteria
+        </button>
       </div>
     </div>
@@ -36,2 +34,3 @@
 }
 
+export default FilterBar;
Index: imaps-frontend/src/components/InfoPinModal/InfoPinModal.jsx
===================================================================
--- imaps-frontend/src/components/InfoPinModal/InfoPinModal.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/InfoPinModal/InfoPinModal.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,204 @@
+import React, { useState, useEffect } from "react";
+import styles from "./InfoPinModal.module.css"; // Reusing the same styles
+
+export default function InfoPinModal(props) {
+  const [modal, setModal] = useState(false);
+  const [pins, setPins] = useState([]);
+  const [room, setRoom] = useState(null);
+
+  const [formData, setFormData] = useState({
+    name: "",
+    description: "",
+    selectedPin: "",
+    availablePins: [],
+    selectedPins: [],
+  });
+
+  const toggleModal = () => {
+    if (modal) {
+      room.info = formData;
+      props.map.updateRoomNames();
+    }
+    setModal(!modal);
+  };
+
+  const handleInputChange = (e) => {
+    const { name, value } = e.target;
+    setFormData((prevData) => ({
+      ...prevData,
+      [name]: value,
+    }));
+  };
+
+  const addPinToList = () => {
+    if (!formData.selectedPin || pins.includes(formData.selectedPin)) return;
+
+    setPins((prevPins) => {
+      const updatedPins = [...prevPins, formData.selectedPin];
+
+      setFormData((prevFormData) => ({
+        ...prevFormData,
+        selectedPin: "",
+        selectedPins: updatedPins,
+      }));
+
+      return updatedPins;
+    });
+  };
+
+  const removePinFromList = (pinToRemove) => {
+    setPins((prevPins) => {
+      const updatedPins = prevPins.filter((pin) => pin !== pinToRemove);
+
+      setFormData((prevFormData) => ({
+        ...prevFormData,
+        selectedPins: updatedPins,
+      }));
+
+      props.map.removeConnection(formData.name, pinToRemove);
+      return updatedPins;
+    });
+  };
+
+  const saveDetails = () => {
+    room.info = formData;
+    toggleModal();
+  };
+
+  useEffect(() => {
+    const openModalHandler = (event) => {
+      const roomObj = event.detail.room;
+
+      setRoom(roomObj);
+
+      // Populate formData and pins based on the room information
+      setFormData({
+        name: roomObj.info.name || "", // Room name
+        description: roomObj.info.description || "",
+        selectedPin: "",
+        availablePins: event.detail.map.getConnections(),
+        selectedPins: roomObj.info.selectedPins,
+      });
+
+      setPins(roomObj.info.selectedPins || []); // Set the already connected pins
+
+      setModal(true); // Open the modal
+      event.detail.map.updateConnections();
+    };
+
+    // Add event listener to open modal
+    window.addEventListener("openPinModalEvent", openModalHandler);
+
+    return () => {
+      // Cleanup the event listener when the component unmounts
+      window.removeEventListener("openPinModalEvent", openModalHandler);
+    };
+  }, []);
+
+  if (modal) {
+    document.body.classList.add(styles.activeModal);
+  } else {
+    document.body.classList.remove(styles.activeModal);
+  }
+
+  return (
+    <>
+      {/* <button onClick={toggleModal} className={styles.btnModal}>
+        Info Pin Modal
+      </button> */}
+
+      {modal && (
+        <div className={styles.modal}>
+          <div onClick={toggleModal} className={styles.overlay}></div>
+          <div className={styles.modalContent}>
+            <h2>Enter Pin Details</h2>
+            <form className={styles.form}>
+              <div className={styles.formGroup}>
+                <label htmlFor="name">Name:</label>
+                <input
+                  type="text"
+                  id="name"
+                  name="name"
+                  value={formData.name}
+                  onChange={handleInputChange}
+                  placeholder="Enter the pin name"
+                  required
+                />
+              </div>
+
+              <div className={styles.formGroup}>
+                <label htmlFor="selectedPin">Select connections:</label>
+                <select
+                  id="selectedPin"
+                  name="selectedPin"
+                  value={formData.selectedPin}
+                  onChange={handleInputChange}
+                  required
+                >
+                  <option value="">Select Connection</option>
+                  {formData.availablePins
+                    .filter(
+                      (pin) =>
+                        formData.selectedPins.includes(pin.name) == false &&
+                        pin.name != "" &&
+                        pin.name != formData.name
+                    )
+                    .map((pin, index) => (
+                      <option key={index} value={pin.name}>
+                        {pin.name}
+                      </option>
+                    ))}
+                </select>
+                <button type="button" onClick={addPinToList} className={styles.addButton}>
+                  Add Connection
+                </button>
+              </div>
+
+              <h3>Connections:</h3>
+              <ul className={styles.pinList}>
+                {pins.length > 0 ? (
+                  pins.map((pin, index) => (
+                    <li key={index} className={styles.pinItem}>
+                      {pin}
+                      <button onClick={() => removePinFromList(pin)} className={styles.removeButton}>
+                        Remove
+                      </button>
+                    </li>
+                  ))
+                ) : (
+                  <li>No connections added</li>
+                )}
+              </ul>
+              <br />
+              <div className={styles.formGroup}>
+                <label htmlFor="description">Description:</label>
+                <textarea
+                  id="description"
+                  name="description"
+                  value={formData.description}
+                  onChange={handleInputChange}
+                  rows="3"
+                  placeholder="Enter description for the pin"
+                />
+              </div>
+
+              <div className={styles.formGroup}>
+                <button
+                  type="button"
+                  id="submit-details"
+                  onClick={saveDetails}
+                  className={styles.submitButton}
+                >
+                  Save
+                </button>
+              </div>
+            </form>
+            <button className={styles.closeModal} onClick={toggleModal}>
+              CLOSE
+            </button>
+          </div>
+        </div>
+      )}
+    </>
+  );
+}
Index: imaps-frontend/src/components/KeyMappingsGuidePanel/KeymapPanel.jsx
===================================================================
--- imaps-frontend/src/components/KeyMappingsGuidePanel/KeymapPanel.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/KeyMappingsGuidePanel/KeymapPanel.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,39 @@
+import { useState } from "react";
+import styles from './KeymapPanel.module.css'; // Import the CSS module
+
+const keyMappings = [
+    { key: 'W', info: 'Move Up' },
+    { key: 'A', info: 'Move Left' },
+    { key: 'S', info: 'Move Down' },
+    { key: 'D', info: 'Move Right' },
+    { key: 'Space', info: 'Jump / Shoot' },
+    { key: 'E', info: 'Interact' },
+    { key: 'Q', info: 'Switch Weapon' }
+];
+
+const KeyboardPanel = () => {
+    const [hoveredKey, setHoveredKey] = useState(null);
+
+    return (
+        <div className={styles.keyboardPanel}>
+            {keyMappings.map((keyItem, index) => (
+                <button
+                    key={index}
+                    className={styles.keyButton}
+                    onMouseEnter={() => setHoveredKey(keyItem.info)}
+                    onMouseLeave={() => setHoveredKey(null)}
+                >
+                    {keyItem.key}
+                </button>
+            ))}
+
+            {hoveredKey && (
+                <div className={styles.keyInfo}>
+                    {hoveredKey}
+                </div>
+            )}
+        </div>
+    );
+};
+
+export default KeyboardPanel;
Index: imaps-frontend/src/components/MapControls/MapControls.jsx
===================================================================
--- imaps-frontend/src/components/MapControls/MapControls.jsx	(revision 79a03170cdde4e801d12257ee86723774970427b)
+++ imaps-frontend/src/components/MapControls/MapControls.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -1,14 +1,10 @@
-import React, {useEffect, useState} from "react";
+import React, { useState } from "react";
 import styles from "./MapControls.module.css";
 import plusIcon from "../../assets/plus_icon.png";
 import minusIcon from "../../assets/minus_icon.png";
 import floorIcon from "../../assets/floor_icon.png";
-import HttpService from "../../scripts/net/HttpService.js";
 
-export default function MapControls({onFloorChange,mapName }) {
-  const [currentFloor, setCurrentFloor] = useState(0);
-  const [floors, setFloors] = useState([]);
-
-  // Starting floor
+export default function MapControls({ onZoomIn, onZoomOut, onFloorChange }) {
+  const [currentFloor, setCurrentFloor] = useState(1); // Starting floor
 
   // Handle floor selection
@@ -24,8 +20,8 @@
       {/* Zoom Controls */}
       <div className={styles.zoomControls}>
-        <button className={styles.zoomButton}>
+        <button onClick={onZoomIn} className={styles.zoomButton}>
           <img src={plusIcon} alt="Zoom In" />
         </button>
-        <button className={styles.zoomButton}>
+        <button onClick={onZoomOut} className={styles.zoomButton}>
           <img src={minusIcon} alt="Zoom Out" />
         </button>
@@ -33,23 +29,17 @@
 
       {/* Floor Selector */}
-      {/*<div className={styles.floorSelector}>*/}
-      {/*  <img src={floorIcon} alt="Floor Icon" className={styles.floorIcon} />*/}
-      {/*  <select*/}
-      {/*    value={currentFloor}*/}
-      {/*    onChange={(e) => handleFloorChange(parseInt(e.target.value, 10))}*/}
-      {/*    className={styles.floorDropdown}*/}
-      {/*  >*/}
-      {/*    {floors?.map(floor => (*/}
-      {/*        <option key={floor.floorNumber} value={floor.floorNumber}>*/}
-      {/*          {floor.floorNumber}F*/}
-      {/*        </option>*/}
-
-      {/*    ))}*/}
-      {/*    /!*<option value={1}>1F</option>*!/*/}
-      {/*    /!*<option value={2}>2F</option>*!/*/}
-      {/*    /!*<option value={3}>3F</option>*!/*/}
-      {/*    /!*<option value={4}>4F</option>*!/*/}
-      {/*  </select>*/}
-      {/*</div>*/}
+      <div className={styles.floorSelector}>
+        <img src={floorIcon} alt="Floor Icon" className={styles.floorIcon} />
+        <select
+          value={currentFloor}
+          onChange={(e) => handleFloorChange(parseInt(e.target.value, 10))}
+          className={styles.floorDropdown}
+        >
+          <option value={1}>1F</option>
+          <option value={2}>2F</option>
+          <option value={3}>3F</option>
+          <option value={4}>4F</option>
+        </select>
+      </div>
     </div>
   );
Index: imaps-frontend/src/components/MapTemplateSelector/LoadMap.jsx
===================================================================
--- imaps-frontend/src/components/MapTemplateSelector/LoadMap.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
+++ imaps-frontend/src/components/MapTemplateSelector/LoadMap.jsx	(revision d56544918790c0c3bc50f2f0a98c99f3d2988ccf)
@@ -0,0 +1,67 @@
+import React, { useState, useEffect } from "react";
+import styles from "./LoadMap.module.css";
+import HttpService from "../../scripts/net/HttpService";
+
+const MapTemplateSelector = ({ loadHandler }) => {
+  const [templates, setTemplates] = useState([]);
+  const [selectedTemplate, setSelectedTemplate] = useState(null);
+  const [loading, setLoading] = useState(true);
+
+  useEffect(() => {
+    const fetchTemplates = async () => {
+      const httpService = new HttpService("http://localhost:8080/api/protected", true);
+      try {
+        const response = await httpService.get("/maps");
+        setTemplates(response);
+        setLoading(false);
+      } catch (error) {
+        console.error("Error fetching templates:", error);
+        setLoading(false);
+      }
+    };
+
+    fetchTemplates();
+  }, []);
+
+  const handleSelect = async (template) => {
+    setSelectedTemplate(template);
+    console.log("Selected template:", template);
+    const httpService = new HttpService("http://localhost:8080/api/protected", true);
+    const response = await httpService.get(`/maps/load?mapName=${template.name}`);
+    console.log("LOAD TEMPLATE: ", response);
+
+    const data = response.map.mapData.textData;
+    loadHandler(data);
+  };
+
+  if (loading) {
+    return <div>Loading map templates...</div>;
+  }
+
+  return (
+    <div className={styles.mapTemplateSelector}>
+      <p>Templates</p>
+      {templates.length > 0 ? (
+        <ul className={styles.templateList}>
+          {templates.map((template) => (
+            <li key={template.id}>
+              <button onClick={() => handleSelect(template)} className={styles.mapTemplateButton}>
+                {template.name}
+              </button>
+            </li>
+          ))}
+        </ul>
+      ) : (
+        <p>No map templates available.</p>
+      )}
+      {selectedTemplate && (
+        <div className={styles.selectedTemplate}>
+          <h3 className={styles.text}>Loaded Template:</h3>
+          <p className={styles.text}>{selectedTemplate.name}</p>
+        </div>
+      )}
+    </div>
+  );
+};
+
+export default MapTemplateSelector;
